// multitasking.cpp
// Copyright 2015 MicroNeil Research Corporation

#include "multitasking.hpp"

void MultiTasker::processBatch(size_t n, MultiTaskQueue& q, bool StopOnWait) {
    size_t batchSize = n;
    while(batchSize--) {
        MultiTask& t = q.get();
        switch(t.task()) {
            case Running: { working.put(t); break; }
            case Waiting: { waiting.put(t); if(StopOnWait) return; break; }
            case Finished: { finished.put(t); break; }
        }
    }
}

MultiTaskState MultiTasker::task() {
    size_t workingBatchSize = working.size();
    size_t waitingBatchSize = waiting.size();
    processBatch(workingBatchSize, working);
    processBatch(waitingBatchSize, waiting, true);

    if(false == working.empty()) { return Running; }
    else if (false == waiting.empty()) { return Waiting; }
    else { return Finished; }
}
